const { SlashCommandBuilder } = require('discord.js');
const { simpleEmbed } = require('../functions/embeds.js');
const { Minecraft, Users } = require('../functions/models.js');

module.exports = {
  data: new SlashCommandBuilder()
    .setName('whitelist')
    .setDescription('Whitelist yourself on the Minecraft server')
    .addStringOption(option => option
      .setName('code')
      .setDescription('6 digit code from Minecraft')
      .setRequired(true)),

  async execute(interaction) {
    const code = interaction.options.getString('code');

    if (code.length !== 6) return await interaction.reply({ embeds: [simpleEmbed('The code must be 6 digits long')], ephemeral: true });

    try {
      const minecraftCol = await Minecraft.findOne({ where: { code: code } });

      if (!minecraftCol) return await interaction.reply({ embeds: [simpleEmbed('The code was not linked with a Minecraft account')], ephemeral: true });

      if (minecraftCol.whitelisted) return await interaction.reply({ embeds: [simpleEmbed('Minecraft account already whitelisted')], ephemeral: true });

      const user = await Users.findOne({ where: { id: interaction.user.id } });

      minecraftCol.whitelisted = true;
      minecraftCol.code = '';

      user.minecraftUUID = minecraftCol.uuid;

      await minecraftCol.save();
      await user.save();
    } catch (error) {
      console.error(error);
    }

    await interaction.reply({ embeds: [simpleEmbed('Successfully whitelisted player ...')], ephemeral: true });
  },
};
